#include <dshow.h>
#include "resource.h"

#pragma comment(lib,"strmiids.lib")

#define MYWNDTITLE		"AudioRecorder"
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define MAX_DEV 		8	// 񋓂I[fBILv`foCX̍ő吔
#define MAX_FMT			32	// 񋓂o̓tH[}bg̍ő吔

ICaptureGraphBuilder2	*g_pCGB = NULL;
IGraphBuilder			*g_pGB	= NULL;
IMediaControl			*g_pMC	= NULL;
IBaseFilter				*g_pSrc[MAX_DEV];	// Lv` tB^

typedef struct{
	ULONG	ChannelsMax;	// `l(ő)
	ULONG	ChannelsMin;	// `l(ŏ)
	ULONG	ChannelsAdd;	// `l()
	ULONG	BpsMax;			// Tṽrbg(ő)
	ULONG	BpsMin;			// Tṽrbg(ŏ)
	ULONG	BpsAdd;			// Tṽrbg()
	ULONG	FreqMax;		// Tvg(ő)
	ULONG	FreqMin;		// Tvg(ŏ)
	ULONG	FreqAdd;		// Tvg()
}INFO_FORMAT;

INFO_FORMAT	g_FMT;		// 񋓂ꂽgp\o̓tH[}bg

typedef struct{
	ULONG	Channels;	// `l
	ULONG	Bps;		// Tṽrbg
	ULONG	Freq;		// Tvg
}CURRENT_FORMAT;

CURRENT_FORMAT	g_CFMT;	// ݑIĂo̓tH[}bg

UINT	g_idxDev = 0;		// ݑIĂLv`tB^̔ԍ
UINT	g_idxPin = 0;		// ݑIĂs̔ԍ
UINT	g_idxPin_Pre = 0;	// vONɗLs̔ԍ
UINT	g_pin_ct = 0;		// 񋓂ꂽs̐
UINT	g_mode_idx = 0;		// s[hi0:ޭ, 1:^, 2:ޭ+^j
char	g_save[MAX_PATH] = "MyWavFile.wav";	// ۑt@C

int CALLBACK ProcDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
int CALLBACK ProcDlgFormat(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void	Init_ProcDlgFormat(HWND hDlg);
bool	Init_Capture(HWND hDlg);
bool	Init_Pins(HWND hDlg);
bool	Init_Filter(HWND hDlg);
bool	Save_WavFile();
void	Enable_Pins();
bool	Get_Format();
bool	Set_Format();
void	Save_FileDlg(HWND hDlg);
void	Cleanup();

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG		msg;
	HWND	hDlg;
	
	hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, ProcDlg);
	ShowWindow(hDlg, nCmdShow);
	
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

int CALLBACK ProcDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			if(FAILED(CoInitialize(NULL))){
				MessageBox(hDlg,"COM ̏Ɏs܂",MYWNDTITLE,MB_OK);
				SendMessage(hDlg,WM_CLOSE,0,0);
				return 0;
			}
			CheckRadioButton(hDlg,IDC_RUN,IDC_STOP,IDC_STOP);
			// s[h̏
			char mode[][32] = {"ޭ","^","ޭ + ^"};
			for(int i=0;i<3;i++){
				SendDlgItemMessage(hDlg,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM) mode[i]);
			}
			SendDlgItemMessage(hDlg,IDC_COMBO3,CB_SETCURSEL,0,0);
			// tB^Ot̏
			Init_Capture(hDlg);
			g_idxPin_Pre = g_idxPin;
		}
		break;

	case WM_COMMAND:
		switch(wParam)
		{
		case IDM_SAVEDLG:	// ۑt@C̎w
			Save_FileDlg(hDlg);
			break;
			
		case IDM_EXIT:	// I
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
			
		case IDM_SETTINGS:	// o̓tH[}bg̐ݒ
			DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_DIALOG2), hDlg, ProcDlgFormat);
			break;
			
		case IDC_COMBO1 | (CBN_SELCHANGE<<16):	// Lv`foCX R{{bNX
			g_idxDev = SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0);
			if(g_idxDev != -1){
				CheckRadioButton(hDlg,IDC_RUN,IDC_STOP,IDC_STOP);
				Cleanup();
				Init_Capture(hDlg);
			}
			break;
			
		case IDC_COMBO2 | (CBN_SELCHANGE<<16):	// ̓s R{{bNX
			g_idxPin = SendDlgItemMessage(hDlg,IDC_COMBO2,CB_GETCURSEL,0,0);
			if(g_idxPin != -1){
				Enable_Pins();
			}
			break;
			
		case IDC_COMBO3 | (CBN_SELCHANGE<<16): // s[h̑I
			g_mode_idx = SendDlgItemMessage(hDlg,IDC_COMBO3,CB_GETCURSEL,0,0);
			if(g_idxDev != -1){
				CheckRadioButton(hDlg,IDC_RUN,IDC_STOP,IDC_STOP);
				Cleanup();
				Init_Capture(hDlg);
			}
			break;
			
		case IDC_RUN | (BN_CLICKED<<16):	// s
			if(g_pMC){
				g_pMC->Run();
				if(g_mode_idx != 0){
					SendMessage(hDlg,WM_SETTEXT,0,(LPARAM)"^EEE");
				}
			}
			break;
			
		case IDC_STOP | (BN_CLICKED<<16):	// ~
			if(g_pMC){
				g_pMC->Stop();
				SendMessage(hDlg,WM_SETTEXT,0,(LPARAM)MYWNDTITLE);
			}
			break;
			
		default:
			return FALSE;
		}
		break;
		
	case WM_CLOSE:
		g_idxPin = g_idxPin_Pre;
		Enable_Pins();
		Cleanup();
		DestroyWindow(hDlg);
		CoUninitialize();
		PostQuitMessage(0);
		break;
		
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlg

// ݒ_CAOvV[W
int CALLBACK ProcDlgFormat(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		Init_ProcDlgFormat(hDlg);
		break;
		
	case WM_COMMAND:
		switch(wParam)
		{
		case IDOK:
			char buf[33];
			g_CFMT.Channels = SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0) + 1;
			SendDlgItemMessage(hDlg,IDC_COMBO2,WM_GETTEXT,sizeof(buf),(LPARAM) buf);
			g_CFMT.Bps = atol(buf);
			SendDlgItemMessage(hDlg,IDC_COMBO3,WM_GETTEXT,sizeof(buf),(LPARAM) buf);
			g_CFMT.Freq = atol(buf);
			Set_Format();
			EndDialog(hDlg,TRUE);
			break;
		case IDCANCEL:
			EndDialog(hDlg,FALSE);
			break;
		default:
			return FALSE;
		}
		break;
		
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlgFormat

void Init_ProcDlgFormat(HWND hDlg)
{
	ULONG		i;
	char		buf[33];
	static char channel[2][8] = {"","ڵ"};
	
	Get_Format();
	
	for(i=g_FMT.ChannelsMin;i<=g_FMT.ChannelsMax;i+=g_FMT.ChannelsAdd){
		SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) channel[i-1]);
	}
	for(i=g_FMT.BpsMin;i<=g_FMT.BpsMax;i+=g_FMT.BpsAdd){
		ltoa(i, buf, 10);
		SendDlgItemMessage(hDlg,IDC_COMBO2,CB_ADDSTRING,0,(LPARAM) buf);
	}
	for(i=g_FMT.FreqMin;i<=g_FMT.FreqMax;i+=g_FMT.FreqAdd){
		ltoa(i, buf, 10);
		SendDlgItemMessage(hDlg,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM) buf);
	}
	
	SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,g_CFMT.Channels-1,0);
	int idx;
	ltoa(g_CFMT.Bps, buf, 10);
	idx = SendDlgItemMessage(hDlg,IDC_COMBO2,CB_FINDSTRING,-1,(LPARAM)buf);
	if(idx != -1){
		SendDlgItemMessage(hDlg,IDC_COMBO2,CB_SETCURSEL,idx,0);
	}
	ltoa(g_CFMT.Freq, buf, 10);
	idx = SendDlgItemMessage(hDlg,IDC_COMBO3,CB_FINDSTRING,-1,(LPARAM)buf);
	if(idx != -1){
		SendDlgItemMessage(hDlg,IDC_COMBO3,CB_SETCURSEL,idx,0);
	}
}// Init_ProcDlgFormat

// tB^Ot}l[W̍쐬ƃI[fBIfoCX̗
bool Init_Capture(HWND hDlg)
{
	HRESULT 				hr;
	LPOLESTR				pClsid = NULL;
	ICreateDevEnum			*pEnum = NULL;
	IEnumMoniker			*pEm = NULL;
	IMoniker				*pM = NULL;
	ULONG					cFetched;
	UINT					ct;
	char					buf[256];
	
	RELEASE(g_pGB);
	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
						  IID_IGraphBuilder, (void **)&g_pGB);
	if(FAILED(hr)){
		return FALSE;
	}
	RELEASE(g_pCGB);
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, 
						  IID_ICaptureGraphBuilder2, (void **)&g_pCGB);
	if(FAILED(hr)){
		return FALSE;
	}
	// gptB^Otw
	if(FAILED(g_pCGB->SetFiltergraph(g_pGB))){
		return FALSE;
	}
	// I[fBILv`foCX̗
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
							IID_ICreateDevEnum, (void**)&pEnum);
	if(FAILED(hr)){
		return FALSE;
	}
	hr = pEnum->CreateClassEnumerator(CLSID_AudioInputDeviceCategory, &pEm, 0);
	if(FAILED(hr)){
		RELEASE(pEnum);
		return FALSE;
	}
	RELEASE(pEnum);
	SendDlgItemMessage(hDlg,IDC_COMBO1,CB_RESETCONTENT,0,0);
	pEm->Reset();
	ct = 0;
	while(S_OK == pEm->Next(1, &pM, &cFetched))
	{
		IPropertyBag *pBag;
		hr = pM->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pBag);
		if(SUCCEEDED(hr))
		{
			VARIANT var;
			var.vt = VT_BSTR;
			hr = pBag->Read(L"FriendlyName", &var, NULL);
			if(SUCCEEDED(hr))
			{
				WideCharToMultiByte(CP_ACP, 0, var.bstrVal, -1, buf, sizeof(buf), NULL, NULL);
				SysFreeString(var.bstrVal);
				RELEASE(g_pSrc[ct]);
				hr = pM->BindToObject(NULL, NULL, IID_IBaseFilter, (void**)&g_pSrc[ct]);
				if(SUCCEEDED(hr)){
					SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) buf);
					ct ++;
					if(ct >= MAX_DEV){
						break;
					}
				}
			}
			RELEASE(pBag);
		}
		RELEASE(pM);
	}
	RELEASE(pEm);
	if(!ct){
		return FALSE;
	}
	
	if(!Init_Pins(hDlg)){
		return FALSE;
	}
	g_idxDev = 0;
	SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,g_idxDev,0);
	if(!Init_Filter(hDlg)){
		return FALSE;
	}
	return TRUE;
}// Init_Capture

// ̓C^[tF[X񋓂ăR{{bNXɕ\
// ݂̗LtO擾āAI
bool Init_Pins(HWND hDlg)
{
	IEnumPins				*pEnum = NULL;
	IPin					*pPin = NULL;
	IAMAudioInputMixer		*pPinMixer = NULL;
	UINT					ct;
	
	if(g_idxDev == -1 || !g_pSrc[g_idxDev]){
		return FALSE;
	}
	SendDlgItemMessage(hDlg,IDC_COMBO2,CB_RESETCONTENT,0,0);
	if(FAILED(g_pSrc[g_idxDev]->EnumPins(&pEnum))){
		return FALSE;
	}
	ct = 0;
	pEnum->Reset();
	while(pEnum->Next(1, &pPin, 0) == S_OK){
		PIN_DIRECTION PinDir;
		if(FAILED(pPin->QueryDirection(&PinDir))){
			RELEASE(pPin);
			continue;
		}
		if(PinDir == PINDIR_INPUT){
			PIN_INFO	pininfo;
			ZeroMemory(&pininfo, sizeof(PIN_INFO));
			if (SUCCEEDED(pPin->QueryPinInfo(&pininfo))){
				// R{{bNXɒǉ
				char	buf[MAX_PIN_NAME];
				WideCharToMultiByte(CP_ACP, 0, pininfo.achName, -1, buf, sizeof(buf), NULL, NULL);
				SendDlgItemMessage(hDlg,IDC_COMBO2,CB_ADDSTRING,0,(LPARAM) buf);
				// ݂̗LtO擾
				if(SUCCEEDED(pPin->QueryInterface(IID_IAMAudioInputMixer, (void **)&pPinMixer))){
					BOOL	fEnable;
					pPinMixer->get_Enable(&fEnable);
					if(fEnable){
						g_idxPin = ct;
					}
					RELEASE(pPinMixer);
				}
				ct ++;
			}
			RELEASE(pininfo.pFilter);
		}
		RELEASE(pPin);
	}
	RELEASE(pEnum);
	g_pin_ct = SendDlgItemMessage(hDlg,IDC_COMBO2,CB_GETCOUNT,0,0);
	SendDlgItemMessage(hDlg,IDC_COMBO2,CB_SETCURSEL,g_idxPin,0);
	return TRUE;
}// Init_Pins

// tB^Ot̐ݒȂ
bool Init_Filter(HWND hDlg)
{
	HRESULT 	hr;
	
	if(g_idxDev == -1 || !g_pSrc[g_idxDev]){
		return FALSE;
	}
	if(FAILED(g_pGB->AddFilter(g_pSrc[g_idxDev], L"Capture"))){
		return FALSE;
	}
	// WAVt@Cɕۑݒ
	if(g_mode_idx != 0){
		if (!Save_WavFile()){
			return FALSE;
		}
	}
	// Lv`CtBjbg s eB[(rfȈꍇ̓X}[g eB[)DirectSound_ڑ
	// iCtBjbg s eB[ ͏o̓sKvǉ邽߂̃tB^ŁA
	// @̏ꍇvr[邽߂̃sȂ̂ŁAtB^Ot}l[WɂĎIɒǉB
	// @DirectSound_́AftHg̏o̓tB^Ȃ̂ŏȗłBj
	if(g_mode_idx != 1){
		hr = g_pCGB->RenderStream(&PIN_CATEGORY_PREVIEW , &MEDIATYPE_Audio, g_pSrc[g_idxDev], NULL, NULL);
		if (FAILED(hr)){
			return FALSE;
		}
	}
	RELEASE(g_pMC);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaControl, (void**)&g_pMC))){
		return FALSE;
	}
	return TRUE;
}// Init_Filter

// WAVt@Cɕۑݒ
//@DXSDK\Samples\C++\DirectShow\BaseClassesrhA
//@DXSDK\Samples\C++\DirectShow\Filters\WavDestrh
//@wavdest.ax 쐬B
//	炩߁Awavdest.ax  C:\\Windows\\System ɃRs[A
//	[X^[g][t@Cw肵Ďs]ŁA
//	Regsvr32 wavdest.ax Ɠ͂[OK]NbNKvB
bool Save_WavFile()
{
	static const GUID CLSID_WavDest =
	{ 0x3c78b8e2, 0x6c4d, 0x11d1, { 0xad, 0xe2, 0x0, 0x0, 0xf8, 0x75, 0x4b, 0x99 } };
	HRESULT 	hr;
	IBaseFilter	*pMux = NULL;
	hr = CoCreateInstance(CLSID_WavDest, NULL, CLSCTX_INPROC_SERVER, 
						  IID_IBaseFilter, (void **)&pMux);
	if(FAILED(hr)){
		MessageBox(0,"Regsvr32 wavdest.ax sĂ",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	if(FAILED(g_pGB->AddFilter(pMux, L"WavDest"))){
		RELEASE(pMux);
		return FALSE;
	}
	IFileSinkFilter2	*pFS = NULL;
	hr = CoCreateInstance(CLSID_FileWriter, NULL, CLSCTX_INPROC_SERVER,
						  IID_IFileSinkFilter2, (void **)&pFS);
	if(FAILED(hr)){
		RELEASE(pMux);
		return FALSE;
	}
	pFS->SetMode(AM_FILE_OVERWRITE);
	IBaseFilter		*pFW = NULL;
	if(FAILED(pFS->QueryInterface(IID_IBaseFilter, (void **)&pFW))){
		RELEASE(pFS);
		RELEASE(pMux);
		return FALSE;
	}
	if(FAILED(g_pGB->AddFilter((IBaseFilter *)pFW, L"FileWriter"))){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		return FALSE;
	}
	WCHAR	wSave[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,g_save,-1,wSave,sizeof(wSave));
	if (FAILED(pFS->SetFileName(wSave, NULL))){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		return FALSE;
	}
	// Lv`WavDestt@CC^ڑ
	hr = g_pCGB->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio, g_pSrc[g_idxDev], pMux, pFW);
	if (FAILED(hr)){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		return FALSE;
	}
	RELEASE(pFW);
	RELEASE(pFS);
	RELEASE(pMux);
	return TRUE;
}// Save_WavFile

// Iꂽ̓C^[tF[XL
void Enable_Pins()
{
	HRESULT				hr;
	IPin				*pPin = NULL;
	IAMAudioInputMixer	*pPinMixer = NULL;
	UINT				i;
	
	for(i=0;i<g_pin_ct;i++){
		if(SUCCEEDED(g_pCGB->FindPin(g_pSrc[g_idxDev], PINDIR_INPUT, NULL, NULL, FALSE, i, &pPin))){
			hr = pPin->QueryInterface(IID_IAMAudioInputMixer, (void **)&pPinMixer);
		    if(SUCCEEDED(hr)){
				if(g_idxPin == i){
					pPinMixer->put_Enable(TRUE);
				}
				else{
					pPinMixer->put_Enable(FALSE);
				}
				RELEASE(pPinMixer);
			}
			RELEASE(pPin);
		}
	}
}// Enable_Pins

// o̓tH[}bg擾
bool Get_Format()
{
	HRESULT hr;
	int		ct = 0,size = 0;
	if(!g_pCGB || g_idxDev == -1 || !g_pSrc[g_idxDev]){
		return FALSE;
	}
	IAMStreamConfig	*pSC = NULL;
	hr = g_pCGB->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio,
					g_pSrc[g_idxDev], IID_IAMStreamConfig, (void **)&pSC);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(pSC->GetNumberOfCapabilities(&ct, &size))){
		RELEASE(pSC);
		return FALSE;
	}
	if(size == sizeof(AUDIO_STREAM_CONFIG_CAPS)){
		AUDIO_STREAM_CONFIG_CAPS	scc;
		AM_MEDIA_TYPE				*pmt;
		for(int i=0;i<ct;i++){
			if(SUCCEEDED(pSC->GetStreamCaps(i, &pmt, (BYTE*)&scc))){
				if( pmt->majortype  == MEDIATYPE_Audio && 
					pmt->subtype    == MEDIASUBTYPE_PCM &&
					pmt->formattype == FORMAT_WaveFormatEx && 
					pmt->pbFormat   != NULL)
				{
					g_FMT.ChannelsMax = scc.MaximumChannels;
					g_FMT.ChannelsMin = scc.MinimumChannels;
					g_FMT.ChannelsAdd = scc.ChannelsGranularity;
					g_FMT.BpsMax      = scc.MaximumBitsPerSample;
					g_FMT.BpsMin      = scc.MinimumBitsPerSample;
					g_FMT.BpsAdd      = scc.BitsPerSampleGranularity;
					g_FMT.FreqMax     = scc.MaximumSampleFrequency;
					g_FMT.FreqMin     = scc.MinimumSampleFrequency;
					g_FMT.FreqAdd     = scc.SampleFrequencyGranularity;
					
					WAVEFORMATEX *wave = (WAVEFORMATEX*) pmt->pbFormat;
					g_CFMT.Channels = wave->nChannels;
					g_CFMT.Bps      = wave->wBitsPerSample;
					g_CFMT.Freq     = wave->nSamplesPerSec;
					
					CoTaskMemFree(pmt->pbFormat);
					CoTaskMemFree(pmt);
					break;
				}
				CoTaskMemFree(pmt->pbFormat);
				CoTaskMemFree(pmt);
			}
		}
	}
	RELEASE(pSC);
	return TRUE; 
}// Get_Format

// o̓tH[}bgݒ
bool Set_Format()
{
	HRESULT hr;
	int		ct = 0,size = 0;
	if(!g_pCGB){
		return FALSE;
	}
	IAMStreamConfig	*pSC = NULL;
	hr = g_pCGB->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Audio,
					g_pSrc[g_idxDev], IID_IAMStreamConfig, (void **)&pSC);
	if(FAILED(hr)){
		return FALSE;
	}
	AM_MEDIA_TYPE mt;
	ZeroMemory(&mt, sizeof(AM_MEDIA_TYPE));
	mt.majortype  = MEDIATYPE_Audio;
	mt.subtype    = MEDIASUBTYPE_PCM;
	mt.formattype = FORMAT_WaveFormatEx;
	mt.cbFormat   = sizeof(WAVEFORMATEX);
	mt.pbFormat   = (BYTE*)CoTaskMemAlloc(sizeof(WAVEFORMATEX));
	WAVEFORMATEX *wave    = (WAVEFORMATEX*) mt.pbFormat;
	ZeroMemory(wave, sizeof(WAVEFORMATEX));
	wave->wFormatTag      = WAVE_FORMAT_PCM;
	wave->nChannels       = (UINT) g_CFMT.Channels;
	wave->nSamplesPerSec  = (UINT) g_CFMT.Freq;
	wave->wBitsPerSample  = (UINT) g_CFMT.Bps;
	wave->nBlockAlign     = wave->nChannels * wave->wBitsPerSample/8;
	wave->nAvgBytesPerSec = wave->nSamplesPerSec * wave->nBlockAlign; 
	wave->cbSize          = 0;
	if(FAILED(pSC->SetFormat(&mt))){
		CoTaskMemFree(mt.pbFormat);
		RELEASE(pSC);
		return FALSE;
	}
	CoTaskMemFree(mt.pbFormat);
	RELEASE(pSC);
	return TRUE;
}// Set_Format

// ۑt@C_CAO
void Save_FileDlg(HWND hDlg)
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH];
	
	strncpy(fn, g_save, sizeof(fn));
	
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hDlg;
	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "̧ (*.wav)\0*.wav\0";
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		strncpy(g_save, fn, sizeof(g_save));
		if(!strrchr(g_save, '.')){
			strcat(g_save, ".wav");
		}
		Cleanup();
		Init_Capture(hDlg);
	}
}// Save_FileDlg

// IuWFNg̉
void Cleanup()
{
	if(g_pMC){
		g_pMC->Stop();
	}
	for(int i=0;i<MAX_DEV;i++){
		RELEASE(g_pSrc[i]);
	}
	RELEASE(g_pMC);
	RELEASE(g_pGB);
	RELEASE(g_pCGB);
}// Cleanup
